/* Serial Laser Turret
Accpets commands through serial port, which are
used to control vertical and horisontal rotation.
Ultra-bright LED and red laser are also controlled.
Clock frequency is 4MHz
*/

#define laser PORTB.B7
#define LED PORTB.B6
#define M1p PORTB.B5
#define M1m PORTB.B4
#define M2p PORTB.B3
#define M2m PORTB.B2

unsigned short uart_rd;

void action(){
// simple error check
   if ((uart_rd & 0b00000011)>0){    // faulty byte received
      PORTB = 0;
      UART1_Write(0);                //  send error
   }else{
      // write outputs
      PORTB = uart_rd;
      UART1_Write(uart_rd);          //  send response
      }
}

void main() {
     UART1_Init(9600);           // Initialize UART module at 9600 bps
     Delay_ms(100);              // Wait for UART module to stabilize
     DDRB = 0b11111100;          // PORTB as output, save PB.1 and 0 which aren't used
     PORTB = 0;                  // Initialize portb
     
 while (1)
 {
       if (UART1_Data_Ready())      // If data is received
       {
        uart_rd = UART1_Read();     //  read the received data,
        action();                   //  write outputs
       }

 }
}
